﻿#include "Functions.h"
#include <vector>
#include <list>
#include <deque>

template < typename T >
void main_menu(T& container)
{
	std::string fileName("test.txt");
	std::string fileNameOut("out_test.txt");
	bool is_running = true;
	int option;

	while (is_running)
	{
		std::cout << std::endl << "Choose func:" << std::endl
			<< "1)createData (Stream)" << std::endl
			<< "2)createData (Iterator)" << std::endl
			<< "3)loadData (Stream)" << std::endl
			<< "4)loadData (Iterator)" << std::endl
			<< "5)Modify (Container)" << std::endl
			<< "6)Modify (Iterator)" << std::endl
			<< "7)Modify (ForEach)" << std::endl
			<< "8)Modify (Transform)" << std::endl
			<< "9)outputResult (Stream)" << std::endl
			<< "10)Print container" << std::endl
			<< "11)outputResult (Copy)" << std::endl
			<< "12)Choose other container" << std::endl << "->  ";

		std::cin >> option;

		std::cout << std::endl;
		try {
			switch (option)
			{
			case 1:
				createData(fileName);
				break;
			case 2:
				createDataIterator(fileName);
				break;
			case 3:
				container = std::move(loadData<T>(fileName));
				break;
			case 4:
				container = std::move(loadDataIterator<T>(fileName));
				break;
			case 5:
				modify(container);
				break;
			case 6:
				modifyIter(container.begin(), container.end());
				break;
			case 7:
				modifyForEach(container);
				break;
			case 8:
				modifyTransform<T>(fileName, fileNameOut);
				break;
			case 9:
				outputResultStream(container, fileNameOut);
				break;
			case 10:
				printContainer(container);
				break;
			case 11:
				outputResultCopy(container, fileNameOut);
				break;
			case 12:
				is_running = false;
				break;
			default:
				std::cout << "Wrong input" << std::endl;
				break;
			}
		}
		catch (std::exception& e)
		{
			std::cout << "Exception: " << e.what() << std::endl;
		}

	}
}

int run()
{
	bool is_running = true;
	int option;

	while (is_running)
	{
		std::cout << std::endl << "Choose container:" << std::endl
			<< "1. Vector" << std::endl
			<< "2. List" << std::endl
			<< "3. Deque" << std::endl
			<< "4. Exit" << std::endl << "->  ";

		std::cin >> option;

		std::cout << std::endl;
		std::deque<int> deq;
		std::list<int> lst;
		std::vector<int> vec;
		switch (option)
		{
		case 1:
			main_menu(deq);
			deq.clear();
			break;
		case 2:
			main_menu(lst);
			lst.clear();
			break;
		case 3:
			main_menu(vec);
			vec.clear();
			break;
		case 4:
			is_running = false;
			break;
		default:
			std::cout << "invalid option" << std::endl;
			break;
		}

	}
	return 1;
}

int main()
{
	run();
	return 0;
}

